#<profile4xi profile = "02" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "authenticationstring4xi.py">
#<abstract4xi abstract = "provides AuthenticationString4Xi class" />
#<refer4xi reference = "process.py" />
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------
# 
# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'AuthenticationString4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass    
try:                 # most-common ones
    import itertools         
except:
    pass
     
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.process import AuthenticationString
except:
    print("authenticationstring4xi.py *** failed in from multiprocessing.process import AuthenticationString ***")
#"
#/>
 
# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from popen4xi import Popen4Xi
from print4xi import print4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi
#"
#/>

# =================================================================================================
#<class4xi class = "AuthenticationString4Xi" base = "bytes" child = "None" synopsis = "Authentification of strings" usage = "
# avoided usage of this class as follows:
#   mainprocess4xi.py:
#     self._authkey = os.urandom(32)
#   basemanager4xi.py:
#     self._authkey = os.urandom(32)
#   baseproxy4xi.py:
#     self._authkey = os.urandom(32)
#   process4xi.py:
#     self._authkey = get_authkey_current_process4xi()
#   server4xi.py:
#     self.authkey = authkey_param
#   _mainprocess4xi.py:
#     self._authkey = os.urandom(32)
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
#
class AuthenticationString4Xi(bytes):
    '''
    AuthenticationString4Xi class
    '''    
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi exposure = "
    _exposed_ = ('sense', 'reason', 'ace')          
    # " />
                               
    
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reduce-of-AuthenticationString4Xi" usage = "reduces">
    # ---------------------------------------------------------------------------------------------
    def __reduce__(self):
        '''
        reduces 
        '''
        class2print = 'AuthenticationString4Xi'
        method2print = '__reduce__'
    
        message2print = "{started" + "; reduce-of-AuthenticationString4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
  
                        
        ack2authentication = False
        nack2authentication = True
    
        # -------------------------------------------------------------------------------------------------    
        #
        # -------------------------------------------------------------------------------------------------
             
        message2print = "{calling" + "; Popen4Xi-thread-is-spawning-calling-by-reduce-of-AuthenticationString4Xi: " + str(Popen4Xi.thread_is_spawning) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
        try:
   
            # ---------------------------------------------------------------------------------------------    
            # 
            # ---------------------------------------------------------------------------------------------     
            
            if not Popen4Xi.thread_is_spawning():

                # -----------------------------------------------------------------------------------------    
                # All authorization keys allowed to make them instances of bytes for forking-pickling
                # -----------------------------------------------------------------------------------------     
            
                message2print = "{yielded" + "; nack2authentication-yielded-by-reduce-of-AuthenticationString4Xi: " + str(nack2authentication)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
    
                message2print = "{warned" + "; security-warned-by-reduce-of-AuthenticationString4Xi: " + " ** Pickling an AuthenticationString object is not recommended for security reasons ** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
             
            else:

                # -----------------------------------------------------------------------------------------    
                # A process authorization key 
                # -----------------------------------------------------------------------------------------     
            
                ack2authentication = True
                
                message2print = "{set" + "; ack2authentication-set-by-reduce-of-AuthenticationString4Xi to: " + str(ack2authentication)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
  
        except:
   
            # ---------------------------------------------------------------------------------------------    
            # All authorization keys allowed to make them instances of bytes for forking-pickling
            # ---------------------------------------------------------------------------------------------     
            
            message2print = "{yielded" + "; nack2authentication-yielded-by-reduce-of-AuthenticationString4Xi: " + str(nack2authentication)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)         
    
        # -------------------------------------------------------------------------------------------------    
        #
        # -------------------------------------------------------------------------------------------------
            
        message2print = "{returning" + "; AuthenticationString4Xi-class-returning-by-reduce-of-AuthenticationString4Xi: " + str(AuthenticationString4Xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)     
 
        
        return AuthenticationString4Xi, (bytes(self),)           
    #</methodize4xi> 
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-AuthenticationString4Xi" usage = "senses AuthenticationString4Xi class objects">
    # ---------------------------------------------------------------------------------------------    
    def sense(self):
        '''
        senses AuthenticationString4Xi class objects
        '''
          
        
        class2print = 'AuthenticationString4Xi'
        method2print = 'sense'
        
        message2print = "{started" + "; sense-of-AuthenticationString4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; AuthenticationString4Xi-sensing-by-sense-of-AuthenticationString4Xi: " + str(AuthenticationString4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-AuthenticationString4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['inheritance-of-authenticationstring2xi'] = "bytes-inherited-by-authenticationstring2xi-of-AuthenticationString4Xi" 
      
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-AuthenticationString4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                    
        message2print = "{sensed" + "; AuthenticationString4Xi-sensed-by-sense-of-AuthenticationString4Xi: " + str(AuthenticationString4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2-returning-by-sense-of-AuthenticationString4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)             
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi> 
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-AuthenticationString4Xi" usage = "reasons AuthenticationString4Xi class objects">
    # ---------------------------------------------------------------------------------------------    
    def reason(self):
        '''
        reasons AuthenticationString4Xi class objects
        '''
                 
        
        class2print = 'AuthenticationString4Xi'
        method2print = 'reason'

        message2print = "{started" + "; reason-of-AuthenticationString4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; AuthenticationString4Xi-reasoning-by-reason-of-AuthenticationString4Xi: "  + str(AuthenticationString4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-AuthenticationString4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; AuthenticationString4Xi-reasoned-by-reason-of-AuthenticationString4Xi: "  + str(AuthenticationString4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-AuthenticationString4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)             
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi> 
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-AuthenticationString4Xi" usage = "aces AuthenticationString4Xi class objects">
    # ---------------------------------------------------------------------------------------------    
    def ace(self):
        '''
        aces AuthenticationString4Xi class objects 
        '''
               
        
        
        class2print = 'AuthenticationString4Xi'
        method2print = 'ace'
        
        message2print = "{started" + "; ace-of-AuthenticationString4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; AuthenticationString4Xi-acing-by-ace-of-AuthenticationString4Xi: " + "AuthenticationString4Xi" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-AuthenticationString4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; AuthenticationString4Xi-aced-by-ace-of-AuthenticationString4Xi: " + "AuthenticationString4Xi" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-AuthenticationString4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)             
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------                          
    #</methodize4xi> 
#</class4xi>

#</program4xi>    

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

    
    

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of authenticationstring4xi.py                            
# ------------------------------------------------------------------------------------------------- 
#"
#/>


